<template>
  <div class="p-2">
    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="22"><span>开票类型信息列表</span> </el-col>
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['customer:settlementMethod:add']">新增</el-button>
          </el-col>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="invoiceTypeList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="编号" align="center" prop="invoiceTypeNo" />
        <el-table-column label="开票类型" align="center" prop="invoiceTypeName" />
        <el-table-column label="是否显示" align="center" prop="isShow">
          <template #default="scope">
            <el-switch v-model="scope.row.isShow" active-value="0" inactive-value="1" @change="handleStatusChange(scope.row)"></el-switch>
          </template>
        </el-table-column>
        <!-- <el-table-column label="数据来源" align="center" prop="dataSource" /> -->
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['system:invoiceType:edit']">编辑</el-button>
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['system:invoiceType:remove']">删除</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改发票类型对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="invoiceTypeFormRef" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="发票类型名称" prop="invoiceTypeName">
          <el-input v-model="form.invoiceTypeName" placeholder="请输入发票类型名称" />
        </el-form-item>
        <el-form-item label="是否显示" prop="isShow">
          <el-radio-group v-model="form.isShow">
            <el-radio v-for="dict in sys_platform_yes_no" :key="dict.value" :value="dict.value">{{ dict.label }}</el-radio>
          </el-radio-group>
        </el-form-item>
        <!-- <el-form-item label="数据来源" prop="dataSource">
          <el-input v-model="form.dataSource" placeholder="请输入数据来源" />
        </el-form-item> -->
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="InvoiceType" lang="ts">
import { listInvoiceType, getInvoiceType, delInvoiceType, addInvoiceType, updateInvoiceType, changeShowStatus } from '@/api/customer/invoiceType';
import { InvoiceTypeVO, InvoiceTypeQuery, InvoiceTypeForm } from '@/api/customer/invoiceType/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const { sys_platform_yes_no } = toRefs<any>(proxy?.useDict('sys_platform_yes_no'));

const invoiceTypeList = ref<InvoiceTypeVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const invoiceTypeFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: InvoiceTypeForm = {
  id: undefined,
  invoiceTypeNo: undefined,
  invoiceTypeName: undefined,
  isShow: '0',
  dataSource: undefined,
  remark: undefined
};
const data = reactive<PageData<InvoiceTypeForm, InvoiceTypeQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    invoiceTypeNo: undefined,
    invoiceTypeName: undefined,
    isShow: undefined,
    dataSource: undefined,
    platformCode: undefined,
    params: {}
  },
  rules: {
    invoiceTypeName: [{ required: true, message: '发票类型名称不能为空', trigger: 'blur' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询发票类型列表 */
const getList = async () => {
  loading.value = true;
  const res = await listInvoiceType(queryParams.value);
  invoiceTypeList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  invoiceTypeFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

const handleStatusChange = async (row: InvoiceTypeVO) => {
  const oldValue = row.isShow; // 保存旧值（0 或 1）

  try {
    await changeShowStatus(row.id, row.isShow); // 传新值
    proxy?.$modal.msgSuccess('操作成功');
  } catch {
    row.isShow = oldValue; // 失败回滚
    proxy?.$modal.msgError('操作失败，请重试');
  }
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: InvoiceTypeVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加发票类型';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: InvoiceTypeVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getInvoiceType(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改发票类型';
};

/** 提交按钮 */
const submitForm = () => {
  invoiceTypeFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateInvoiceType(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addInvoiceType(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: InvoiceTypeVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除发票类型编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delInvoiceType(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'system/invoiceType/export',
    {
      ...queryParams.value
    },
    `invoiceType_${new Date().getTime()}.xlsx`
  );
};

onMounted(() => {
  getList();
});
</script>
